image: $CI_REGISTRY_IMAGE:latest

variables:
    WORKDIR: /app

stages:
    - test
    - dockerbuild
    - deploy

Testing Code against Development Server:
    stage: test
    rules:
        - if: '$CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "development"'
          when: always
    environment:
        name: development
    before_script:
        - echo "Beginning preparing environment"
        - 'echo "Selected Environment: $CI_ENVIRONMENT_NAME"'
        - cd ${WORKDIR}
        # Choosing environment
        - echo 'Creating .env using GitLab variables from $ENV in environment $CI_ENVIRONMENT_NAME'
        - "[[ -z $ENV ]] && { echo 'Variable in environment $CI_ENVIRONMENT_NAME is missing from GitLab Environment Variable. Please create it on Repository Setting > CI / CD > Variables'; exit 1; }"
        - cat $ENV > .env
        - source .env

        # Install package
        - yarn install
    script:
        - yarn run test
    after_script:
        - rm .env

docker build staging:
    stage: dockerbuild
    image: docker:stable
    environment:
        name: staging
    services:
        - docker:dind
    before_script:
        - docker info
        - docker login registry.gitlab.com -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD}

        - echo "Beginning preparing environment"
        - 'echo "Selected Environment: $CI_ENVIRONMENT_NAME"'
        # Choosing environment
        - echo 'Creating .env using GitLab variables from $ENV in environment $CI_ENVIRONMENT_NAME'
        - "[[ -z $ENV ]] && { echo 'Variable in environment $CI_ENVIRONMENT_NAME is missing from GitLab Environment Variable. Please create it on Repository Setting > CI / CD > Variables'; exit 1; }"
        - cat $ENV > .env
        - source .env
    script:
        - docker build -t $CI_REGISTRY_IMAGE:$CI_ENVIRONMENT_NAME .
        - docker push $CI_REGISTRY_IMAGE:$CI_ENVIRONMENT_NAME
    artifacts:
        expire_in: 1 hour
        paths:
            - build
            - node_modules/
    after_script:
        - docker logout ${CI_REGISTRY}
    only:
        - staging

gcloud deploy staging:
    stage: deploy
    image: google/cloud-sdk
    environment:
        name: staging
    before_script:
        - echo $SERVICE_ACCOUNT | base64 --decode > ${CI_PROJECT_DIR}/key.json
        - gcloud auth activate-service-account --key-file ${CI_PROJECT_DIR}/key.json
        - gcloud config set project $GKE_PROJECT
        - gcloud config set compute/zone $GKE_ZONE
        - gcloud config set account $GKE_ACCOUNT
        - gcloud container clusters get-credentials $GKE_CLUSTER --zone=$GKE_ZONE --project=$GKE_PROJECT
    script:
        - kubectl apply -f standard-app-staging.yaml
        - kubectl rollout restart deployment frontend-one-rnd -n one-rnd-staging
    only:
        - staging

docker build prod:
    stage: dockerbuild
    image: docker:stable
    environment:
        name: production
    services:
        - docker:dind
    before_script:
        - docker info
        - docker login registry.gitlab.com -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD}

        - echo "Beginning preparing environment"
        - 'echo "Selected Environment: $CI_ENVIRONMENT_NAME"'
        # Choosing environment
        - echo 'Creating .env using GitLab variables from $ENV in environment $CI_ENVIRONMENT_NAME'
        - "[[ -z $ENV ]] && { echo 'Variable in environment $CI_ENVIRONMENT_NAME is missing from GitLab Environment Variable. Please create it on Repository Setting > CI / CD > Variables'; exit 1; }"
        - cat $ENV > .env
        - source .env
    script:
        - docker build -t $CI_REGISTRY_IMAGE:$CI_ENVIRONMENT_NAME .
        - docker push $CI_REGISTRY_IMAGE:$CI_ENVIRONMENT_NAME
    artifacts:
        expire_in: 1 hour
        paths:
            - build
            - node_modules/
    after_script:
        - docker logout ${CI_REGISTRY}
    only:
        - master

gcloud deploy prod:
    stage: deploy
    image: google/cloud-sdk
    environment:
        name: producction
    before_script:
        - echo $SERVICE_ACCOUNT | base64 --decode > ${CI_PROJECT_DIR}/key.json
        - gcloud auth activate-service-account --key-file ${CI_PROJECT_DIR}/key.json
        - gcloud config set project $GKE_PROJECT
        - gcloud config set compute/zone $GKE_ZONE
        - gcloud config set account $GKE_ACCOUNT
        - gcloud container clusters get-credentials $GKE_CLUSTER --zone=$GKE_ZONE --project=$GKE_PROJECT
    script:
        - kubectl apply -f standard-app.yaml
        - kubectl rollout restart deployment frontend-one-rnd -n one-rnd-prod
    only:
        - master
